-- Pretty-Printed using HW2 Pretty-Printer 1.21 by Mikail.
-- LuaDC version 0.9.19
-- 5/23/2004 7:30:55 PM
-- LuaDC by Age2uN
-- on error send source file (compiled lua) and this outputfile to Age2uN@gmx.net
--
DEF_on = 0
DEF_off = 1
DEF_out = 2
DEF_low = 3
Resource = 2
Fighter = 3
Corvette = 4
Support = 5
MISC = 6
Capital = 7
Frigate = 8
SubSystem = 9
Platform = 10
Megalith = 11
Flagship = 12
NumAllPilots = 5
NumCapPilots = 4
NumFighterPilots = 3
NumInfiltratorPilots = 2
NumMarinePilots = 2
NumSupportPilots = 3
NameAllPilot = "All_"
NameCapPilot = "Cap_"
NameFighterPilot = "Fighter_"
NameInfiltratorPilot = "Infiltrator_"
NameMarinePilot = "Marine_"
NameSupportPilot = "Support_"
NameFleetCommand = "Fleet"
NameMakaan = "Makaan"
Frequency_Command = 0.5
Frequency_Status = 2
Frequency_Chatter = 5
Hiigaran = 1
Vaygr = 2
MP_AllianceRequested = 0
MP_AllianceFormed = 1
MP_AllianceBroken = 2
MP_RUsTransferred = 3
MP_ShipsTransferred = 4
HYP_Entering = 0
HYP_EnteringGate = 1
HYP_Exiting = 2
HYP_Interrupted = 3
HYP_GateFormed = 4
HYP_EnteredInhibitorVolume = 5
HYP_NotEnoughCash = 6
AggressiveTactics = 0
DefensiveTactics = 1
PassiveTactics = 2
CloseRange = 0
MediumRange = 1
LongRange = 2
ACT_Selected = 1
ACT_Created = 2
ACT_Reinforced = 3

-- adding new ships in a map makes for less ship specific code
-- shipCommandMap index should be in lower case (due to strlowers below)
shipCommandMap = {}
-- map to hold overrides of commands index should be command as it appears below
shipCommandOverride = {}
shipCommandMap.hur_starbuck = 
{
	"hur_starbuck_",  -- the directory sound\speech\allships\ which contains this ships voices (minus the number)
	1,                -- how many different pilots from 1 to this number is appended to the directory named above
}

-----------------------------------------------
shipCommandMap.hur_boomer = 
{
	"hur_boomer_",    -- the directory sound\speech\allships\ which contains this ships voices (minus the number)
	1,                -- how many different pilots from 1 to this number is appended to the directory named above
}

shipCommandOverride.hur_boomer = {}

-- if defined the default speech will be used for any command speeches not explictly defined (even those that exist) so use with caution
shipCommandOverride.hur_boomer.DEFAULT = 
{
	"COMMAND_Selected",
}

sscMap = {}
sscMap.Battlecruiser = {}
sscMap.Carrier = {}
sscMap.Shipyard = {}
sscMap.MotherShip = {}
sscMap.Carrier.C_PRODUCTION_FIGHTER = "STATUS_FighterFacilityConstructedFromCarrier_1"
sscMap.Carrier.C_PRODUCTION_CORVETTE = "STATUS_CorvetteFacilityConstructedFromCarrier_1"
sscMap.Carrier.C_PRODUCTION_FRIGATE = "STATUS_FrigateFacilityConstructedFromCarrier_1"
sscMap.Carrier.C_PRODUCTION_FRIGATEADVANCED = "STATUS_AdvancedFrigateFacilityConstructedFromCarrier_1"
sscMap.Carrier.C_MODULE_PLATFORMCONTROL = "STATUS_PlatformFacilityConstructedFromCarrier_1"
sscMap.Carrier.C_MODULE_RESEARCH = "STATUS_ResearchModuleConstructedFromCarrier_1"
sscMap.Carrier.C_MODULE_CLOAKGENERATOR = "STATUS_CloakGeneratorConstructedFromCarrier_1"
sscMap.Carrier.C_MODULE_FIRECONTROL = "STATUS_FireControlTowerConstructedFromCarrier_1"
sscMap.Carrier.C_SENSORS_ADVANCEDARRAY = "STATUS_SensorsArrayConstructedFromCarrier_1"
sscMap.Carrier.C_MODULE_HYPERSPACE = "STATUS_HyperspaceCoreConstructedFromCarrier_1"
sscMap.Shipyard.MS_PRODUCTION_FIGHTER = "STATUS_FighterFacilityConstructedFromShipyard_1"
sscMap.Shipyard.MS_PRODUCTION_CORVETTE = "STATUS_CorvetteFacilityConstructedFromShipyard_1"
sscMap.Shipyard.MS_PRODUCTION_FRIGATE = "STATUS_FrigateFacilityConstructedFromShipyard_1"
sscMap.Shipyard.MS_PRODUCTION_FRIGATEADVANCED = "STATUS_AdvancedFrigateFacilityConstructedFromShipyard_1"
sscMap.Shipyard.MS_MODULE_PLATFORMCONTROL = "STATUS_PlatformFacilityConstructedFromShipyard_1"
sscMap.Shipyard.SY_PRODUCTION_CAPSHIP = "STATUS_CapitalShipFacilityConstructedFromShipyard_1"
sscMap.Shipyard.MS_MODULE_RESEARCH = "STATUS_ResearchModuleConstructedFromShipyard_1"
sscMap.Shipyard.MS_MODULE_CLOAKGENERATOR = "STATUS_CloakGeneratorConstructedFromShipyard_1"
sscMap.Shipyard.MS_MODULE_HYPERSPACE = "STATUS_HyperspaceCoreConstructedFromShipyard_1"
sscMap.Shipyard.MS_MODULE_FIRECONTROL = "STATUS_FireControlTowerConstructedFromShipyard_1"
sscMap.Battlecruiser.C_MODULE_CLOAKGENERATOR = "STATUS_CloakGeneratorConstructedFromBattlecruiser_1"
sscMap.Battlecruiser.C_MODULE_FIRECONTROL = "STATUS_FireControlTowerConstructedFromBattlecruiser_1"
sscMap.Battlecruiser.C_MODULE_HYPERSPACE = "STATUS_HyperspaceCoreConstructedFromBattlecruiser_1"
sscMap.Battlecruiser.C_MODULE_RESEARCH = "STATUS_ResearchModuleConstructedFromBattlecruiser_1"
sscMap.MotherShip.MS_PRODUCTION_FIGHTER = "STATUS_FighterFacilityConstructedFromMothership_1"
sscMap.MotherShip.MS_PRODUCTION_CORVETTE = "STATUS_CorvetteFacilityConstructedFromMothership_1"
sscMap.MotherShip.MS_PRODUCTION_FRIGATE = "STATUS_FrigateFacilityConstructedFromMothership_1"
sscMap.MotherShip.MS_PRODUCTION_FRIGATEADVANCED = "STATUS_AdvancedFrigateFacilityConstructedFromMothership_1"
sscMap.MotherShip.MS_MODULE_PLATFORMCONTROL = "STATUS_PlatformFacilityConstructedFromMothership_1"
sscMap.MotherShip.MS_MODULE_RESEARCH = "STATUS_ResearchModuleConstructedFromMothership_1"
sscMap.MotherShip.MS_MODULE_CLOAKGENERATOR = "STATUS_CloakGeneratorConstructedFromMothership_1"
sscMap.MotherShip.MS_MODULE_FIRECONTROL = "STATUS_FireControlTowerConstructedFromMothership_1"
sscMap.MotherShip.MS_SENSORS_ADVANCEDARRAY = "STATUS_SensorsArrayConstructedFromMothership_1"
sscMap.MotherShip.MS_MODULE_HYPERSPACE = "STATUS_HyperspaceCoreConstructedFromMothership_1"
sscMap.MotherShip.MS_MODULE_RESEARCHADVANCED = "STATUS_AdvResearchModuleConstructedFromMothership_1"
sscMap.MotherShip.MS_PRODUCTION_CAPSHIP = "STATUS_CapitalShipFacilityConstructedFromMothership_1"
sscMap.MotherShip.MS_PRODUCTION_CAPSHIPADVANCED = "STATUS_AdvancedCapitalShipFacilityConstructedFromMothership_1"
stdCMap = {}
stdCMap.Hgn_Scout = "STATUS_ScoutConstructed_1"
stdCMap.Hgn_Interceptor = "STATUS_InterceptorConstructed_1"
stdCMap.Hgn_AttackBomber = "STATUS_BomberConstructed_1"
stdCMap.Hgn_AttackBomberElite = "STATUS_BomberConstructed_1"
stdCMap.Hgn_AssaultCorvette = "STATUS_AssaultCorvetteConstructed_1"
stdCMap.Hgn_AssaultCorvetteElite = "STATUS_AssaultCorvetteConstructed_1"
stdCMap.Hgn_PulsarCorvette = "STATUS_PulsarCorvetteConstructed_1"
stdCMap.Hgn_MinelayerCorvette = "STATUS_MinelayerCorvetteConstructed_1"
stdCMap.Hgn_AssaultFrigate = "STATUS_AssaultFrigateConstructed_1"
stdCMap.Hgn_TorpedoFrigate = "STATUS_TorpedoFrigateConstructed_1"
stdCMap.Hgn_TorpedoFrigateElite = "STATUS_TorpedoFrigateConstructed_1"
stdCMap.Hgn_SupportFrigate = "STATUS_SupportFrigateConstructed_1"
stdCMap.Hgn_MarineFrigate = "STATUS_MarineFrigateConstructed_1"
stdCMap.Hgn_DefenseFieldFrigate = "STATUS_DefenseFieldFrigateConstructed_1"
stdCMap.Hgn_Destroyer = "STATUS_DestroyerConstructed_1"
stdCMap.Hgn_Carrier = "STATUS_CarrierConstructed_1"
stdCMap.Hgn_Battlecruiser = "STATUS_BattlecruiserConstructed_1"
stdCMap.Hgn_Shipyard = "STATUS_ShipyardConstructed_1"
stdCMap.Hgn_GunTurret = "STATUS_GunTurretConstructed_1"
stdCMap.Hgn_IonTurret = "STATUS_IonCannonTurretConstructed_1"
stdCMap.Hgn_ResourceCollector = "STATUS_ResourceCollectorConstructed_1"
stdCMap.Hgn_ResourceController = "STATUS_ResourceControllerConstructed_1"
stdCMap.Hgn_Probe = "STATUS_ProbeConstructed_1"
stdCMap.Hgn_ECMProbe = "STATUS_ProbeConstructed_1"
stdCMap.Hgn_ProximitySensor = "STATUS_ProximitySensorConstructed_1"
stdCMap.Vgr_Scout = "STATUS_VScoutConstructed_1"
stdCMap.Vgr_Interceptor = "STATUS_VInterceptorConstructed_1"
stdCMap.Vgr_Crusader = "STATUS_VCrusaderConstructed_1"
stdCMap.Vgr_LanceFighter = "STATUS_VLanceFighterConstructed_1"
stdCMap.Vgr_Bomber = "STATUS_VBomberConstructed_1"
stdCMap.Vgr_LaserCorvette = "STATUS_VLaserCorvetteConstructed_1"
stdCMap.Vgr_MissileCorvette = "STATUS_VMissileCorvetteConstructed_1"
stdCMap.Vgr_MinelayerCorvette = "STATUS_VMinelayerCorvetteConstructed_1"
stdCMap.Vgr_CommandCorvette = "STATUS_VCommandCorvetteConstructed_1"
stdCMap.Vgr_AssaultFrigate = "STATUS_VAssaultFrigateConstructed_1"
stdCMap.Vgr_InfiltratorFrigate = "STATUS_VInfiltratorFrigateConstructed_1"
stdCMap.Vgr_HeavyMissileFrigate = "STATUS_VHvyMissilFrigateConstructed_1"
stdCMap.Vgr_TransportFrigate = "STATUS_VTransportFrigateConstructed_1"
stdCMap.Vgr_ShipYard = "STATUS_VShipyardConstructed_1"
stdCMap.Vgr_Carrier = "STATUS_VCarrierConstructed_1"
stdCMap.Vgr_Battlecruiser = "STATUS_VBattleCruiserConstructed_1"
stdCMap.Vgr_Destroyer = "STATUS_VDestroyerConstructed_1"
stdCMap.Vgr_ResourceCollector = "STATUS_VResourceCollectorConstructed_1"
stdCMap.Vgr_ResourceController = "STATUS_VResourceControllerConstructed_1"
stdCMap.Vgr_Probe = "STATUS_VProbeConstructed_1"
stdCMap.Vgr_Probe_ECM = "STATUS_VEmpProbeConstructed_1"
stdCMap.Vgr_Probe_Prox = "STATUS_VProxProbeConstructed_1"
stdCMap.Vgr_HyperSpace_Platform = "STATUS_VHyperspacePlatformConstructed_1"
BUILD_Std = 1
BUILD_Subsystem = 2

-- for the shipCommandMap and shipCommandOverride if the command is explictly defined in shipCommandOverride, it will be used.  If it is not explictly defined, the default will beused.  if the default isn't defined it will use command has the sound directory.
function CommandBsg(bsgShipName, command)
   	if (shipCommandMap["" .. bsgShipName]) then -- make sure the ship is really defined otherwise an error results
        if (shipCommandOverride["" .. bsgShipName]) then
    	    if (shipCommandOverride["" .. bsgShipName][command]) then		
      		    playSpeechActor(shipCommandOverride["" .. bsgShipName][command][1], shipCommandMap["" .. bsgShipName][1], shipCommandMap["" .. bsgShipName][2], Frequency_Status)
            elseif (shipCommandOverride["" .. bsgShipName]["DEFAULT"]) then		
       		    playSpeechActor(shipCommandOverride["" .. bsgShipName]["DEFAULT"][1], shipCommandMap["" .. bsgShipName][1], shipCommandMap["" .. bsgShipName][2], Frequency_Status)
    		end
    	else
           playSpeechActor(command, shipCommandMap["" .. bsgShipName][1], shipCommandMap["" .. bsgShipName][2], Frequency_Status)
        end
	end
end

function raceHelper()	
	if (currentRace == Vaygr) then	
		return
		NameMakaan
	else
		return
		NameFleetCommand
	end
end

function getType(shipnm)	
--	if (shipnm == "Hgn_MotherShip" or shipnm == "Vgr_MotherShip") then	
--		return
--		Flagship
--	end
	shipnmU = strupper(shipnm)
	if (strfind(shipnmU, "PLATFORM") or strfind(shipnmU, "TURRET")) then	
		return
		Platform
	end
	if (strfind(shipnmU, "DEBRIS")) then	
		return
		MISC
	end
--	if (strfind(shipnmU, "KPR_")) then	
--		return
--		MISC
--	end
	familyName = "" .. getFamily(shipnm)
	if (familyName == "CAPITAL" or familyName == "SUPERCAP" or familyName == "SMALLCAPITALSHIP" or familyName == "BIGCAPITALSHIP") then	
		return
		Capital
	end
	if (familyName == "FRIGATE" or familyName == "CAPTURER") then	
		return
		Frigate
	end
	if (familyName == "UTILITY" or familyName == "RESOURCE" or familyName == "RESOURCELARGE") then	
		return
		Resource
	end
	if (familyName == "CORVETTE") then	
		return
		Corvette
	end
	if (familyName == "FIGHTER") then	
		return
		Fighter
	end
	if (familyName == "MEGALITH") then	
		return
		Megalith
	end
	if (familyName == "FLAGSHIP" or familyName == "MOTHERSHIP") then	
		return
		Flagship
	end
	if (familyName == "SUBSYSTEM" or familyName == "SUBSYSTEMMODULE" or strfind(shipnmU, "MODULE")) then	
		return
		SubSystem
	end
	if (familyName == "PLATFORM") then	
		return
		Platform
	end
	return
	0
end

function CommandMoveToSobGiven(shipname, targetname)	
--    print("  ** ** ** CommandMoveToSobGiven: shipname = " .. shipname .. ", targetname = " .. targetname)
	if (strfind(strupper(targetname), "NEBULA")) then		
        -- if adding a new ship it is best to add it to shipCommandMap above
		if (shipCommandMap["" .. shipname]) then
		    CommandBsg(shipname, "COMMAND_OrderedToEnterNebula")
			return
		end	
		playSpeechActor("COMMAND_OrderedToEnterNebula", NameAllPilot, NumAllPilots, Frequency_Command)
		return
	end
	CommandMoveGiven(shipname, targetname)
end

function isCapital(shipnm)	
	if (getType(shipnm) == Capital) then	
		return
		1
	end
	return
	0
end

function CommandWayPointMoveGiven(shipname, targetname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Waypoint")
   		return
   	end		
end

function CommandCancelOrder(shipname, prevOrders)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then -- 0 move, 1 attack
		CommandBsg(shipname, "COMMAND_CancelOrder" .. prevOrders)
   		return
   	end		
end

function CommandDefenseFieldChanged(shipname, defenseType)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then -- 0 on, 1 off, 2 out, 3 low
		CommandBsg(shipname, "COMMAND_DefenseField" .. defenseType)
   		return
   	end		
end

function CommandResourceGiven(shipname, targetname)	-- "StaticContainer"
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Resource")
   		return
   	end		
end

function CommandMultiplay(shipname, event)	
	if (event == MP_AllianceRequested) then	
		playSpeechActor("COMMAND_AllianceRequested_1", raceHelper(), 0, Frequency_Command)
	elseif (event == MP_AllianceFormed) then	
		playSpeechActor("COMMAND_AllianceFormed_1", raceHelper(), 0, Frequency_Command)
	elseif (event == MP_AllianceBroken) then	
		playSpeechActor("COMMAND_AllianceBroken_1", raceHelper(), 0, Frequency_Command)
	elseif (event == MP_RUsTransferred) then	
		playSpeechActor("COMMAND_RUs_Transferred", raceHelper(), 0, Frequency_Command)
	elseif (event == MP_ShipsTransferred) then	
		playSpeechActor("COMMAND_Ships_Transferred", raceHelper(), 0, Frequency_Command)
	end
end

function CommandCaptureGiven(shipname, targetname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Capture")
   		return
   	end		
end

function CommandAttackGiven(shipname, targetname, attackType)	
--	print("******** COMMAND ATTACK: shipname, targetname, attackType = " .. shipname .. "," .. targetname .. "," .. attackType)

    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Attack")
   		return
   	end		


	if (attackType == 3) then	
		if (shipname == "Hgn_Dreadnaught") then	
			playSpeechActor("COMMAND_Dreadnaught_BigGun", NameCapPilot, NumCapPilots, Frequency_Command)
			return
		elseif (shipname == "Hgn_Scout") then	
			playSpeechActor("COMMAND_ScoutEmp", NameSupportPilot, NumSupportPilots, Frequency_Command)
			return
		end
	end
	local targetShipType = getType(targetname)
	local shipType = getType(shipname)
	genericShipName = strsub(shipname, 5)
--	print("******2- COMMAND ATTACK: shipType, targetShipType, genericShipName = " .. shipType .. "," .. targetShipType .. "," .. genericShipName)
	if (attackType == 0 or attackType == 3) then	
		if (shipType == Flagship and genericShipName ~= "Dreadnaught") then	
			playSpeechActor("COMMAND_Attack", raceHelper(), 0, Frequency_Command)
			return
		end
		if (targetShipType == Capital) then	
			playSpeechActor("COMMAND_Attack_CapShip", NameCapPilot, NumCapPilots, Frequency_Command)
		elseif (targetShipType == SubSystem and targetname ~= "VGR_HYPERSPACEINHIBITOR") then	
			playSpeechActor("COMMAND_BOMBERSUBSYSTEMATTACK", NameFighterPilot, NumFighterPilots, Frequency_Command)
		elseif (shipType == Capital) then	
			playSpeechActor("COMMAND_CAPSHIP_TO_ATTACK", NameCapPilot, NumCapPilots, Frequency_Command)
		elseif (shipname == "STRIKE") then	
			playSpeechActor("COMMAND_StrikeGroup_Attack", NameAllPilot, NumAllPilots, Frequency_Command)
		else
			playSpeechActor("COMMAND_Attack", NameFighterPilot, NumFighterPilots, Frequency_Command)
		end
	elseif (attackType == 1) then	
		if (shipType == Flagship and genericShipName ~= "Dreadnaught") then	
			playSpeechActor("COMMAND_ForceAttackFriendly_1", raceHelper(), 0, Frequency_Command)
			return
		end
		playSpeechActor("COMMAND_ForceAttackFriendly", NameCapPilot, NumCapPilots, Frequency_Command)
	elseif (attackType == 2) then	
		if (shipType == Flagship and genericShipName ~= "Dreadnaught") then	
			playSpeechActor("COMMAND_ForceAttack_1", raceHelper(), 0, Frequency_Command)
			return
		end
		playSpeechActor("COMMAND_ForceAttack", NameCapPilot, NumCapPilots, Frequency_Command)
	end
end

function CommandHyperspaceGiven(shipname, code)	
--	print("** CommandHyperspaceGiven: shipname = " .. shipname .. " code = " .. code)
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then -- 1 entering gate, 3 Interrupted, 5 EnteredInhibitorVolume, 6 NotEnoughCash
		CommandBsg(shipname, "COMMAND_Jump" .. code)
   		return
   	end		
end

function CommandCombatMan(shipname, targetname)	
--    print("*** *** CommandCombatMan: shipname, targetname: "..shipname..", "..targetname) 
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_CombatMan")
   		return
   	end		
end

function CommandMoveAttackGiven(shipname, targetname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_MoveAttack")	
   		return
   	end		
end

function CommandLaunchGiven(shipname, targetname)	

    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Launch")	
   		return
   	end		
end

function CommandGuardGiven(shipname, targetname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Guard")	
   		return
   	end		
end


function CommandMoveGiven(shipnm, targetnm)	
	if (shipCommandMap["" .. shipnm]) then
	    CommandBsg(shipnm, "COMMAND_Move")
		return
	end
end

-- it appears shipnm can sometimes be null here... check of shipnm before using it
function CommandStrikeGroupFormed(shipnm, code)	
	if (code == 1) then	
		playSpeechActor("COMMAND_STRIKEGROUP_FORM_RESPONSE", NameAllPilot, NumAllPilots, Frequency_Command)
	elseif (code == 2) then	
		playSpeechActor("COMMAND_STRIKEGROUP_FORMATIONSET", NameAllPilot, NumAllPilots, Frequency_Command)
	elseif (code == 3) then	
		playSpeechActor("COMMAND_STRIKEGROUP_DISBAND", NameAllPilot, NumAllPilots, Frequency_Command)
	end
end

function CommandDockGiven(shipname, targetname)	
	shipType = getType(shipname)
	genericShipName = strsub(targetname, 5)
	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Dock")	
   		return
   	end		
end

function CommandParadeGiven(shipname, targetname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Parade")	
   		return
   	end		
end

function CommandRetireGiven(shipname, targetname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Retire")	
   		return
   	end		
end

function CommandTacticsChanged(shipname, newSetting)
	if (shipCommandMap["" .. shipname]) then
	    CommandBsg(shipname, "COMMAND_SetTactics" .. newSetting)
		return
	end
end

function CommandEngagementRangeChanged(shipname, newSetting)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then	-- 0 is CloseRange, 1 MediumRange, 2 LongRange
		CommandBsg(shipname, "COMMAND_SetRange" .. newSetting)	
   		return
   	end		
end

function CommandEngagementRangeForceChanged(shipname, force)	
	if (force == 1) then	
		playSpeechActor("COMMAND_SetRangeForce", NameAllPilot, NumAllPilots, Frequency_Command)
	end
end

function CommandHotKeyGroupSelected(shipname, groupNumber, keyAction)	
	if (keyAction == ACT_Created) then	
		if (groupNumber == 10) then	
			playSpeechActor("COMMAND_GROUP_Assigned_10", raceHelper(), 0, Frequency_Command)
		else
			playSpeechActor("COMMAND_GROUP_Assigned_0" .. groupNumber, raceHelper(), 0, Frequency_Command)
		end
		return
	end
	if (keyAction == ACT_Reinforced) then	
		if (groupNumber == 10) then	
			playSpeechActor("STATUS_HotkeyGroup_Added_20_2", raceHelper(), 0, Frequency_Command)
		else
			playSpeechActor("STATUS_HotkeyGroup_Added_0" .. groupNumber .. "_2", raceHelper(), 0, Frequency_Command)
		end
		return
	end
	if (groupNumber == 10) then	
		playSpeechActor("COMMAND_SelectGroup10", NameCapPilot, NumCapPilots, Frequency_Command)
	else
		playSpeechActor("COMMAND_SelectGroup0" .. groupNumber, NameCapPilot, NumCapPilots, Frequency_Command)
	end
end

function CommandShipsSelected(shipname)	
    -- if adding a new ship it is best to add it to shipCommandMap above
   	if (shipCommandMap["" .. shipname]) then
		CommandBsg(shipname, "COMMAND_Selected")	
   		return
   	end		
end

function CommandConstructionComplete(buildingShip, builtItem, buildType)	
--	print(" *  *  *  *  * ---- CommandConstructionComplete : buildingShip="..buildingShip..", builtItem="..builtItem..", buildType="..buildType)
	if not buildingShip or not
	builtItem then	
		return
	end
	
    -- if adding a new ship it is best to add it to shipCommandMap above
    local builtItemLower = strlower(builtItem)
   	if (shipCommandMap["" .. builtItemLower]) then
		CommandBsg(builtItemLower, "COMMAND_ConstructionComplete")	
   		return
   	end	
end

function CommandConstructionStarted(buildingShip, builtItem)	
--	print(" *  *  *  *  * ---- CommandConstructionStarted : buildingShip="..buildingShip..", builtItem="..builtItem)

    -- if adding a new ship it is best to add it to shipCommandMap above
    local builtItemLower = strlower(builtItem)
   	if (shipCommandMap["" .. builtItemLower]) then
		CommandBsg(builtItemLower, "COMMAND_ConstructionStarted")	
   		return
   	end		
end

function CommandPaused(temp)	
	playSpeechActor("COMMAND_Build_Paused", raceHelper(), 0, Frequency_Command)
end
