-- Pretty-Printed using HW2 Pretty-Printer 1.21 by Mikail.
-- LuaDC version 0.9.19
-- 5/23/2004 7:30:55 PM
-- LuaDC by Age2uN
-- on error send source file (compiled lua) and this outputfile to Age2uN@gmx.net
--

g_default_frequency = 10
g_low_frequency = 30
CD_MissileIncoming = 1
CD_DefenseFieldFound = 2
CD_CapturedAtUnitCap = 3
CD_CaptureHalfway = 4
CD_CaptureStarted = 5
CD_ShipArrived = 8
CD_ShipSpotted = 9
CD_ShipEmergingFromHyperpace = 10
CD_EnemyCaptureStarted = 11
CD_EnteredInhibitorVolume = 14
Frequency_Command = 0.5
Frequency_Status = 2
Frequency_Chatter = 5

-- shipStatus Map used to add new sounds while avoiding default sounds
shipStatusMap = {} -- index should be in lower case (due to strlowers below)

-- shipStatus Map used to point one status speech at another
shipStatusOverride = {}

shipStatusMap.hur_starbuck = 
{
	"hur_starbuck_",  -- the directory sound\speech\allships\ which contains this ships voices (minus the number)
	1,                -- how many different pilots from 1 to this number is appended to the directory named above
}

shipStatusMap.hur_boomer = 
{
	"hur_boomer_",    -- the directory sound\speech\allships\ which contains this ships voices (minus the number)
	1,                -- how many different pilots from 1 to this number is appended to the directory named above
}

-- shipStatusOverride index should be in lower case (due to strlowers below)
shipStatusOverride.hur_boomer = {}

-- if defined the default speech will be used for any command speeches not explictly defined (even those that exist) so use with caution
shipStatusOverride.hur_boomer.DEFAULT = 
{
	"STATUS_Nothing", -- no status for boomer by default
}

---------------------------------------------------------------------------------------------------------

FC_OVERRIDE_DISTSQR = 2000
AggressiveTactics = 0
DefensiveTactics = 1
PassiveTactics = 2
MAX_CAMERA = 5000
StartingRepairs = 0
WorkingOnRepairs = 1
FinishedRepairs = 2
TOOLOW = 0.28
RAND_SWITCH = 0
CLOUD_OrderedToEnterNebula = 0
CLOUD_EnteringNebula = 1
CLOUD_EnteringDustcloud = 2
CLOUD_LostEnemy = 3
CLOUD_TakingDamage = 4
CLOUD_LostEnemyNebula = 5
ssMap = {}
ssMap.Battlecruiser = {}
ssMap.Carrier = {}
ssMap.Shipyard = {}
ssMap.MotherShip = {}

ssMap.Battlecruiser.BATTLECRUISERENGINE = 
{
	"STATUS_BATTLECRUISER_EnginesUnderAttack_1",
	"STATUS_BATTLECRUISER_EnginesDamaged_1",
	"STATUS_BATTLECRUISER_EnginesDisabled_1",
}

ssMap.Battlecruiser.C_MODULE_CLOAKGENERATOR = 
{
	"STATUS_BATTLECRUISER_CloakGeneratorUnderAttack_1",
	"STATUS_BATTLECRUISER_CloakGeneratorDamaged_1",
	"STATUS_BATTLECRUISER_CloakGeneratorDestroyed_1",
}

ssMap.Battlecruiser.C_MODULE_FIRECONTROL = 
{
	"STATUS_BATTLECRUISER_FireControlTowerUnderAttack_1",
	"STATUS_BATTLECRUISER_FireControlTowerDamaged_1",
	"STATUS_BATTLECRUISER_FireControlTowerDestroyed_1",
}

ssMap.Battlecruiser.C_MODULE_HYPERSPACE = 
{
	"STATUS_BATTLECRUISER_HyperspaceCoreUnderAttack_1",
	"STATUS_BATTLECRUISER_HyperspaceCoreDamaged_1",
	"STATUS_BATTLECRUISER_HyperspaceCoreDestroyed_1",
}

ssMap.Battlecruiser.C_MODULE_RESEARCH = 
{
	"STATUS_BATTLECRUISER_ResearchModuleUnderAttack_1",
	"STATUS_BATTLECRUISER_ResearchModuleDamaged_1",
	"STATUS_BATTLECRUISER_ResearchModuleDestroyed_1",
}

ssMap.Carrier.C_ENGINE = 
{
	"STATUS_CARRIER_EnginesUnderAttack_1",
	"STATUS_CARRIER_EnginesDamaged_1",
	"STATUS_CARRIER_EnginesDisabled_1",
}

ssMap.Carrier.C_MODULE_CLOAKGENERATOR = 
{
	"STATUS_CARRIER_CloakGeneratorUnderAttack_1",
	"STATUS_CARRIER_CloakGeneratorDamaged_1",
	"STATUS_CARRIER_CloakGeneratorDestroyed_1",
}

ssMap.Carrier.C_MODULE_FIRECONTROL = 
{
	"STATUS_CARRIER_FireControlTowerUnderAttack_1",
	"STATUS_CARRIER_FireControlTowerDamaged_1",
	"STATUS_CARRIER_FireControlTowerDestroyed_1",
}

ssMap.Carrier.C_MODULE_HYPERSPACE = 
{
	"STATUS_CARRIER_HyperspaceCoreUnderAttack_1",
	"STATUS_CARRIER_HyperspaceCoreDamaged_1",
	"STATUS_CARRIER_HyperspaceCoreDestroyed_1",
}

ssMap.Carrier.C_MODULE_PLATFORMCONTROL = 
{
	"STATUS_CARRIER_PlatformFacilityUnderAttack_1",
	"STATUS_CARRIER_PlatformFacilityDamaged_1",
	"STATUS_CARRIER_PlatformFacilityDestroyed_1",
}

ssMap.Carrier.C_MODULE_RESEARCH = 
{
	"STATUS_CARRIER_ResearchModuleUnderAttack_1",
	"STATUS_CARRIER_ResearchModuleDamaged_1",
	"STATUS_CARRIER_ResearchModuleDestroyed_1",
}

ssMap.Carrier.C_PRODUCTION_CORVETTE = 
{
	"STATUS_CARRIER_CorvetteFacilityUnderAttack_1",
	"STATUS_CARRIER_CorvetteFacilityDamaged_1",
	"STATUS_CARRIER_CorvetteFacilityDestroyed_1",
}

ssMap.Carrier.C_PRODUCTION_FIGHTER = 
{
	"STATUS_CARRIER_FighterFacilityUnderAttack_1",
	"STATUS_CARRIER_FighterFacilityDamaged_1",
	"STATUS_CARRIER_FighterFacilityDestroyed_1",
}

ssMap.Carrier.C_PRODUCTION_FRIGATE = 
{
	"STATUS_CARRIER_FrigateFacilityUnderAttack_1",
	"STATUS_CARRIER_FrigateFacilityDamaged_1",
	"STATUS_CARRIER_FrigateFacilityDestroyed_1",
}

ssMap.Carrier.C_PRODUCTION_FRIGATEADVANCED = 
{
	"STATUS_CARRIER_AdvancedFrigateFacilityUnderAttack_1",
	"STATUS_CARRIER_AdvancedFrigateFacilityDamaged_1",
	"STATUS_CARRIER_AdvancedFrigateFacilityDestroyed_1",
}

ssMap.Carrier.C_SENSORS_ADVANCEDARRAY = 
{
	"STATUS_CARRIER_SensorArrayUnderAttack_1",
	"STATUS_CARRIER_SensorArrayDamaged_1",
	"STATUS_CARRIER_SensorArrayDestroyed_1",
}

ssMap.Shipyard.MS_MODULE_CLOAKGENERATOR = 
{
	"STATUS_SHIPYARD_CloakGeneratorUnderAttack_1",
	"STATUS_SHIPYARD_CloakGeneratorDamaged_1",
	"STATUS_SHIPYARD_CloakGeneratorDestroyed_1",
}

ssMap.Shipyard.MS_MODULE_FIRECONTROL = 
{
	"STATUS_SHIPYARD_FireControlTowerUnderAttack_1",
	"STATUS_SHIPYARD_FireControlTowerDamaged_1",
	"STATUS_SHIPYARD_FireControlTowerDestroyed_1",
}

ssMap.Shipyard.MS_MODULE_HYPERSPACE = 
{
	"STATUS_SHIPYARD_HyperspaceCoreUnderAttack_1",
	"STATUS_SHIPYARD_HyperspaceCoreDamaged_1",
	"STATUS_SHIPYARD_HyperspaceCoreDestroyed_1",
}

ssMap.Shipyard.MS_MODULE_RESEARCH = 
{
	"STATUS_SHIPYARD_ResearchModuleUnderAttack_1",
	"STATUS_SHIPYARD_ResearchModuleDamaged_1",
	"STATUS_SHIPYARD_ResearchModuleDestroyed_1",
}

ssMap.Shipyard.MS_MODULE_PLATFORMCONTROL = 
{
	"STATUS_SHIPYARD_PlatformFacilityUnderAttack_1",
	"STATUS_SHIPYARD_PlatformFacilityDamaged_1",
	"STATUS_SHIPYARD_PlatformFacilityDestroyed_1",
}

ssMap.Shipyard.MS_PRODUCTION_CORVETTE = 
{
	"STATUS_SHIPYARD_CorvetteFacilityUnderAttack_1",
	"STATUS_SHIPYARD_CorvetteFacilityDamaged_1",
	"STATUS_SHIPYARD_CorvetteFacilityDestroyed_1",
}

ssMap.Shipyard.MS_PRODUCTION_FIGHTER = 
{
	"STATUS_SHIPYARD_FighterFacilityUnderAttack_1",
	"STATUS_SHIPYARD_FighterFacilityDamaged_1",
	"STATUS_SHIPYARD_FighterFacilityDestroyed_1",
}

ssMap.Shipyard.MS_PRODUCTION_FRIGATE = 
{
	"STATUS_SHIPYARD_FrigateFacilityUnderAttack_1",
	"STATUS_SHIPYARD_FrigateFacilityDamaged_1",
	"STATUS_SHIPYARD_FrigateFacilityDestroyed_1",
}

ssMap.Shipyard.MS_PRODUCTION_FRIGATEADVANCED = 
{
	"STATUS_SHIPYARD_AdvancedFrigateFacilityUnderAttack_1",
	"STATUS_SHIPYARD_AdvancedFrigateFacilityDamaged_1",
	"STATUS_SHIPYARD_AdvancedFrigateFacilityDestroyed_1",
}

ssMap.Shipyard.SY_INNATE_ENGINE = 
{
	"STATUS_SHIPYARD_EnginesUnderAttack_1",
	"STATUS_SHIPYARD_EnginesDamaged_1",
	"STATUS_SHIPYARD_EnginesDisabled_1",
}

ssMap.Shipyard.SY_PRODUCTION_CAPSHIP = 
{
	"STATUS_SHIPYARD_CapitalShipFacilityUnderAttack_1",
	"STATUS_SHIPYARD_CapitalShipFacilityDamaged_1",
	"STATUS_SHIPYARD_CapitalShipFacilityDestroyed_1",
}

ssMap.MotherShip.MS_MODULE_CLOAKGENERATOR = 
{
	"STATUS_Mothership_CloakGeneratorUnderAttack_1",
	"STATUS_Mothership_CloakGeneratorDamaged_1",
	"STATUS_Mothership_CloakGeneratorDestroyed_1",
}

ssMap.MotherShip.MS_MODULE_FIRECONTROL = 
{
	"STATUS_Mothership_FireControlTowerUnderAttack_1",
	"STATUS_Mothership_FireControlTowerDamaged_1",
	"STATUS_Mothership_FireControlTowerDestroyed_1",
}

ssMap.MotherShip.MS_MODULE_HYPERSPACE = 
{
	"STATUS_Mothership_HyperspaceCoreUnderAttack_1",
	"STATUS_Mothership_HyperspaceCoreDamaged_1",
	"STATUS_Mothership_HyperspaceCoreDestroyed_1",
}

ssMap.MotherShip.MS_MODULE_RESEARCH = 
{
	"STATUS_Mothership_ResearchModuleUnderAttack_1",
	"STATUS_Mothership_ResearchModuleDamaged_1",
	"STATUS_Mothership_ResearchModuleDestroyed_1",
}

ssMap.MotherShip.MS_MODULE_PLATFORMCONTROL = 
{
	"STATUS_Mothership_PlatformFacilityUnderAttack_1",
	"STATUS_Mothership_CorvetteFacilityDamaged_1",
	"STATUS_Mothership_PlatformFacilityDestroyed_1",
}

ssMap.MotherShip.MS_PRODUCTION_CORVETTE = 
{
	"STATUS_Mothership_CorvetteFacilityUnderAttack_1",
	"STATUS_SHIPYARD_CorvetteFacilityDamaged_1",
	"STATUS_Mothership_CorvetteFacilityDestroyed_1",
}

ssMap.MotherShip.MS_PRODUCTION_FIGHTER = 
{
	"STATUS_Mothership_FighterFacilityUnderAttack_1",
	"STATUS_Mothership_FighterFacilityDamaged_1",
	"STATUS_Mothership_FighterFacilityDestroyed_1",
}

ssMap.MotherShip.MS_PRODUCTION_FRIGATE = 
{
	"STATUS_Mothership_FrigateFacilityUnderAttack_1",
	"STATUS_SHIPYARD_FrigateFacilityDamaged_1",
	"STATUS_Mothership_FrigateFacilityDestroyed_1",
}

ssMap.MotherShip.MS_PRODUCTION_FRIGATEADVANCED = 
{
	"STATUS_Mothership_AdvancedFrigateFacilityUnderAttack_1",
	"STATUS_Mothership_AdvancedFrigateFacilityDamaged_1",
	"STATUS_Mothership_AdvancedFrigateFacilityDestroyed_1",
}

ssMap.MotherShip.MS_INNATE_ENGINE = 
{
	"STATUS_Mothership_EnginesUnderAttack_1",
	"STATUS_Mothership_EnginesDamaged_1",
	"STATUS_Mothership_EnginesDisabled_1",
}

ssMap.MotherShip.MS_PRODUCTION_CAPSHIP = 
{
	"STATUS_Mothership_CapitalShipFacilityUnderAttack_1",
	"STATUS_Mothership_CapitalShipFacilityDamaged_1",
	"STATUS_Mothership_CapitalShipFacilityDestroyed_1",
}

ssMap.MotherShip.MS_SENSORS_ADVANCEDARRAY = 
{
	"STATUS_Mothership_SensorArrayUnderAttack_1",
	"STATUS_Mothership_SensorArrayDamaged_1",
	"STATUS_Mothership_SensorArrayDestroyed_1",
}

ssMap.MotherShip.MS_PRODUCTION_CAPSHIPADVANCED = 
{
	"STATUS_Mothership_AdvancedCapitalShipFacilityUnderAttack_1",
	"STATUS_Mothership_AdvancedCapitalShipFacilityDamaged_1",
	"STATUS_Mothership_AdvancedCapitalShipFacilityDestroyed_1",
}

ssMap.MotherShip.MS_MODULE_RESEARCHADVANCED = 
{
	"STATUS_ARM_UnderAttack_2",
	"STATUS_ARM_Damaged_1",
	"STATUS_ARM_Destroyed_1",
}

UnderAttack = 1
Damaged = 2
Destroyed = 3
Repaired = 4
varyEngineSpeech = 0

-- for the shipStatusMap and shipStatusOverride if the status is explictly defined in shipStatusOverride, it will be used.  If it is not explictly defined, the default will beused.  if the default isn't defined it will use status has the sound directory.
function StatusBsg(bsgShipName, status)
--    print("  SOUNDSCRIPT: " .. bsgShipName .. " status:" .. status)
   	if (shipStatusMap["" .. bsgShipName]) then -- make sure the ship is really defined otherwise an error results
        if (shipStatusOverride["" .. bsgShipName]) then
    	    if (shipStatusOverride["" .. bsgShipName][status]) then		
      		    playSpeechActor(shipStatusOverride["" .. bsgShipName][status][1], shipStatusMap["" .. bsgShipName][1], shipStatusMap["" .. bsgShipName][2], Frequency_Status)
            elseif (shipStatusOverride["" .. bsgShipName]["DEFAULT"]) then		
       		    playSpeechActor(shipStatusOverride["" .. bsgShipName]["DEFAULT"][1], shipStatusMap["" .. bsgShipName][1], shipStatusMap["" .. bsgShipName][2], Frequency_Status)
    		end
    	else
           playSpeechActor(status, shipStatusMap["" .. bsgShipName][1], shipStatusMap["" .. bsgShipName][2], Frequency_Status)
        end
	end
end


function ChatterMisc(shipnm, parm2, code)	
--	print(" *   *   * ChatterMisc: shipnm = " .. shipnm .. " parm2 = " .. parm2 .. " code = " .. code)
    -- if adding a new ship it is best to add it to shipStatusMap above
	if (shipStatusMap["" .. shipnm]) then -- 1 MissileIncoming, 2 DefenseFieldFound, 14 EnteredInhibitorVolume
	    StatusBsg(shipnm, "CHATTER_Misc" .. code)
		return
	end	
end

function ChatterMiscHighPriority(shipnm, parm2, code)	
--	print(" *   *   * ChatterMiscHighPriority: shipnm = " .. shipnm .. " parm2 = " .. parm2 .. " code = " .. code)
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipnm]) then -- 3 CapturedAtUnitCap, 4 CaptureHalfway, 5 CaptureStarted, 8 ShipArrived, 9 ShipSpotted, 10 ShipEmergingFromHyperpace, 11 EnemyCaptureStarted 
	    StatusBsg(shipnm, "CHATTER_MiscHighPriority" .. code)
   		return
	end
end

-- enemy seems to often be not defined.
function StatusUnderAttack(shipnm, enemy, attackcode)	
--	print("****** StatusUnderAttack: shipnm, enemy, attackcode = {" .. shipnm .. "," .. enemy .. "," .. attackcode .. "}")
	if (attackcode > FC_OVERRIDE_DISTSQR) then	
			return
	end
	if (shipStatusMap["" .. shipnm]) then	
	    StatusBsg(shipnm, "STATUS_UnderAttack")
		return
	end
end

function StatusRetaliating(retaliatingShipName, currentTactics)	
--    print("**** StatusRetaliating: retaliatingShipName =" .. retaliatingShipName .. ", and currentTactics = " .. currentTactics)
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. retaliatingShipName]) then	-- 0 is aggressive, 1 defensive, 2 passive
	    StatusBsg(retaliatingShipName, "STATUS_Retaliating" .. currentTactics)
   		return
   	end		
end

function StatusUnderFireNeedOrders(underFireShipName, targetShipName, groupNumber)	
--    print("**** StatusUnderFireNeedOrders: underFireShipName =" .. underFireShipName .. ", and targetShipName = " .. targetShipName .. ", and groupNumber = " .. groupNumber)
	if (groupNumber == -1) then	
        -- if adding a new ship it is best to add it to shipStatusMap above
       	if (shipStatusMap["" .. underFireShipName]) then	
		    StatusBsg(underFireShipName, "STATUS_UnderAttack")
       		return
       	end				
		playSpeechActor("STATUS_GenericGroupUnderAttack_Report", NameAllPilot, NumAllPilots, Frequency_Status)
	else
		playSpeechActor("STATUS_AssignedGroupUnderAttack_Report_G" .. groupNumber, raceHelper(), 0, Frequency_Status)
	end
end

function StatusCaptureComplete(shipnm, targetnm, cameradistance)	
--    print("**** StatusCaptureComplete: shipnm =" .. shipnm .. ", and targetnm = " .. targetnm, " and cameradistance = " .. cameradistance)
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. targetnm]) then 
	    StatusBsg(targetnm, "STATUS_Captured")
   	end		
   	if (shipStatusMap["" .. shipnm]) then 
	    StatusBsg(shipnm, "STATUS_CaptureComplete")
		return
   	end	
end

function StatusInMineField(underFireShipName, groupNumber)	
	if (groupNumber == -1) then	

        -- if adding a new ship it is best to add it to shipStatusMap above
       	if (shipStatusMap["" .. underFireShipName]) then	
		    StatusBsg(underFireShipName, "STATUS_InMineField")
       		return
       	end				

		if (underFireShipName == "STRIKE") then	
			playSpeechActor("STATUS_StrikeGroup_InMines", NameAllPilot, NumAllPilots, Frequency_Status)
		else
			playSpeechActor("STATUS_GenericGroupInMineField", NameAllPilot, NumAllPilots, Frequency_Status)
		end
	else
		mineAttackSnd = "STATUS_GROUP"
		if (groupNumber < 10) then	
			mineAttackSnd = mineAttackSnd .. "0"
		end
		mineAttackSnd = mineAttackSnd .. groupNumber .. "_INMINEFIELD"
		playSpeechActor(mineAttackSnd, NameAllPilot, NumAllPilots, Frequency_Status)
	end
end

function StatusAttackComplete(shipName, groupnum)
	if (groupnum == -1) then	

        -- if adding a new ship it is best to add it to shipStatusMap above
       	if (shipStatusMap["" .. shipName]) then	
		    StatusBsg(shipName, "STATUS_AttackComplete")
       		return
       	end	
		
		playSpeechActor("CHATTER_GenericGroupBattleWon_Report", NameAllPilot, NumAllPilots, Frequency_Status)
	elseif (groupnum < 0) then	
		playSpeechActor("STATUS_AttackComplete", NameAllPilot, NumAllPilots, Frequency_Status)
	else
		grpWonSnd = "STATUS_HotkeyGroup_Victory_"
		if (groupnum < 10) then	
			grpWonSnd = grpWonSnd .. "0"
		end
		playSpeechActor(grpWonSnd .. groupnum, raceHelper(), 0, Frequency_Status)
	end
end

function StatusRepairs(shipName, targetName, repairStatus)	
--	print("**** StatusRepairs: shipName =" .. shipName .. ", and repairStatus = " .. repairStatus, " and targetName = " .. targetName)
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. targetName]) then -- 0 StartingRepairs, 1 WorkingOnRepairs, 2 FinishedRepairs
	    StatusBsg(targetName, "STATUS_Repairs".. repairStatus)
   	end		
   	if (shipStatusMap["" .. shipName]) then -- 0 StartingRepairs, 1 WorkingOnRepairs, 2 FinishedRepairs
	    StatusBsg(shipName, "STATUS_Repairs".. repairStatus)
		return
   	end		
end

function StatusShipDestroyed(shipName, code)	
--	print("**** StatusShipDestroyed: shipName =" .. shipName .. ", and code = " .. code)
	if (code > 0) then	
		if (code == 10) then	
			playSpeechActor("STATUS_HOTKEYGROUP_DEFEAT_10", raceHelper(), 0, Frequency_Command)
		else
			playSpeechActor("STATUS_HOTKEYGROUP_DEFEAT_0" .. code, raceHelper(), 0, Frequency_Command)
		end
		return
	end

    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_ShipDestroyed")
   		return
   	end		
end

function StatusShipDocked(shipName, dockedWithName)	
--    print(" * * * * StatusShipDocked = " ..shipName .. ", dockedWithName = " .. dockedWithName)
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_ShipDocked")
   		return
	end
end

function StatusTakingLightDamage(shipName, healthpercentage)	
--	print(" *** StatusTakingLightDamage: name = " .. shipName .. " Health = " .. healthpercentage)
	if (healthpercentage < TOOLOW) then	
		return
	end

    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_TakingLightDamage")
   		return
   	end		
end

function StatusTakingHeavyDamage(shipName)	
--	print(" *** StatusTakingHeavyDamage: " .. shipName)
	
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_TakingHeavyDamage")
   		return
   	end		
end

function StatusDamaged(shipName)	
--	print(" *** StatusDamaged: " .. shipName)
	RAND_SWITCH = (1 -RAND_SWITCH)
	
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_Damaged")
   		return
   	end		
end

function StatusResources(shipname, actionType)	
	if (actionType == 1) then	
		playSpeechActor("STATUS_RESOURCEPOCKETEXHAUSTEDGOINGTONEXTPOCKET_1", NameSupportPilot, NumSupportPilots, Frequency_Status)
	elseif (actionType == 2) then	
		playSpeechActor("STATUS_RESOURCEPOCKETENEMIESDETECTED_1", NameSupportPilot, NumSupportPilots, Frequency_Status)
	elseif (actionType == 3) then	
		playSpeechActor("STATUS_RESOURCEPOCKETEXHAUSTEDGOINGIDLE_1", NameSupportPilot, NumSupportPilots, Frequency_Status)
	elseif (actionType == 6) then	
		playSpeechActor("STATUS_RESOURCECOLLECTORIDLE", NameSupportPilot, NumSupportPilots, Frequency_Status)
	end
end

function StatusCriticallyDamaged(shipName)	
--	print(" *** StatusCriticallyDamaged: " .. shipName)	
	
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_CriticallyDamaged")
   		return
	end
end

function StatusBattleMomentum(momentum)	
--	print("** Battle Momentum Value: " .. momentum)
	if (momentum > 5) then	
		playSpeechActorLinked("CHATTER_GenericGroupStartBattleAdvantaged_Report", NameAllPilot, NumAllPilots, Frequency_Status, CE_CHT_ADVRESPONSE)
	elseif (momentum > 4) then	
		playSpeechActorLinked("CHATTER_GenericGroupWinningBattle_Report", NameAllPilot, NumAllPilots, Frequency_Status, CE_CHT_WINRESPONSE)
	elseif (momentum > 2) then	
		playSpeechActor("CHATTER_GenericGroupPositiveBattle_Report", NameAllPilot, NumAllPilots, Frequency_Status)
	elseif (momentum > 0.125) then	
		playSpeechActorLinked("CHATTER_GenericGroupStartBattleFair_Report", NameAllPilot, NumAllPilots, Frequency_Status, CE_CHT_FAIRRESPONSE)
	elseif (momentum < 0.125) then	
		playSpeechActor("STATUS_GenericGroupLosingBadly_Report", NameAllPilot, NumAllPilots, Frequency_Status)
	elseif (momentum < 0.25) then	
		playSpeechActorLinked("CHATTER_GenericGroupLosingBattle_Report", NameAllPilot, NumAllPilots, Frequency_Status, CE_CHT_LOSERESPONSE)
	elseif (momentum < 0.5) then	
		playSpeechActor("CHATTER_GenericGroupNegativeBattle_Report", NameAllPilot, NumAllPilots, Frequency_Status)
	end
end

function StatusCloud(shipname, evtype)	
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipname]) then -- 0 OrderedToEnterNebula, 1 EnteringNebula, 2 EnteringDustcloud, 3 LostEnemy, 4 TakingDamage, 5 LostEnemyNebula
	    StatusBsg(shipname, "STATUS_Cloud" .. evtype)
   		return
	end
end

function StatusSubsystem(ssname, shipName, event)	
	genericShipName = strsub(shipName, 5)
	genericssname = strsub(ssname, 5)
	if (genericssname == "MS_INNATE_RESOURCE") then	
		return
	end
	if (strfind(genericssname, "ENGINE")) then	
		varyEngineSpeech = (varyEngineSpeech + 1)
		if (mod(varyEngineSpeech, 3) ~= 0) then	
			return
		end
	end
--	print(" *  *  *  *  * ---- StatusSubsystem : ssname="..ssname..", shipName="..shipName..", event="..event)
	if (ssMap["" .. genericShipName] and ssMap["" .. genericShipName]["" .. genericssname] and event ~= Repaired) then	
		if (genericShipName == "Shipyard") then	
			playSpeechActor(ssMap["" .. genericShipName]["" .. genericssname][event], NameSupportPilot, NumSupportPilots, Frequency_Status)
		elseif (genericShipName == "Carrier" or genericShipName == "Battlecruiser") then	
			playSpeechActor(ssMap["" .. genericShipName]["" .. genericssname][event], NameCapPilot, NumCapPilots, Frequency_Status)
		elseif (genericShipName == "MotherShip") then	
			playSpeechActor(ssMap["" .. genericShipName]["" .. genericssname][event], raceHelper(), 0, Frequency_Status)
		end
		return
	elseif (event == Repaired) then	
		if (genericShipName == "Shipyard") then	
			playSpeechActor("STATUS_SHIPYARD_EnginesRepaired_1", NameSupportPilot, NumSupportPilots, Frequency_Status)
		elseif (genericShipName == "Carrier") then	
			playSpeechActor("STATUS_CARRIER_EnginesRepaired_1", NameCapPilot, NumCapPilots, Frequency_Status)
		elseif (genericShipName == "Battlecruiser" and genericssname == "BATTLECRUISERENGINE") then	
			playSpeechActor("STATUS_BATTLECRUISER_EnginesRepaired_1", NameCapPilot, NumCapPilots, Frequency_Status)
		end
		return
	end
	if (event == Destroyed) then	
		playSpeechActor("STATUS_SubsystemDestroyed_2", raceHelper(), 0, Frequency_Status)
	end
end

function BattleChatMisc(ssname, parm2, code)	
--	print(" *   *   * BattleChatMisc: ssname = " .. ssname .. " parm2 = " .. parm2 .. " code = " .. code)
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. ssname]) then -- 1 HitFromBehind, 2 HitFromTopOrBottom, 3 OneManStanding
	    StatusBsg(ssname, "CHATTER_BattleMisc" .. code)
   		return
	end
end

function StatusBuildAvailable(shipName)	
--	print("build available "..shipName)
	
    -- if adding a new ship it is best to add it to shipStatusMap above
	local shipNameLower = strlower(shipName)
   	if (shipStatusMap["" .. shipNameLower]) then
	    StatusBsg(shipNameLower, "STATUS_BuildAvaliable")
   		return
	end
end

function StatusHyperspaceExit(shipName)	
    -- if adding a new ship it is best to add it to shipStatusMap above
   	if (shipStatusMap["" .. shipName]) then
	    StatusBsg(shipName, "STATUS_JumpExit")
   		return
	end
end

-- these temps seemed to be undefined most if not all of the time :(
function StatusResearchComplete(temp)	
	playSpeechActor("STATUS_RESEARCHCOMPLETE_1", raceHelper(), 0, Frequency_Status)
end

function StatusHyperspaceInterrupted(temp)	
	playSpeechActor("STATUS_HyperspaceInterupted_1", raceHelper(), 0, Frequency_Status)
end

function StatusResearchAvailable(temp)	
	playSpeechActor("STATUS_ResearchAvaliable_1", raceHelper(), 0, Frequency_Status)
end

function StatusResearchNoRUs(temp)	
	playSpeechActor("STATUS_ResearchNoRUs_1", raceHelper(), 0, Frequency_Status)
end

function StatusUpgradeComplete(temp)	
	playSpeechActor("STATUS_UpgradeComplete_1", raceHelper(), 0, Frequency_Status)
end

function StatusUpgradeAvailable(temp)	
	playSpeechActor("STATUS_UpgradeAvaliable_1", raceHelper(), 0, Frequency_Status)
end

function StatusUpdgradeNoRUs(temp)	
	playSpeechActor("STATUS_UpgradeNoRUs_1", raceHelper(), 0, Frequency_Status)
end

